/*
	ppps_int_clist.c
	[TvCu] int^̑ozXg
	
	author:  K.Y (Programming Place Plus)
	
	version  1.0.2   '2019/9/16
	           EWebTCg C99Ki֑ΉƂɍ킹āAR[hCB
			     RgX^CƁAϐ錾ʒuςB
                 bool^gB

	         1.0.1   '2018/3/19
	           Eppps_int_clist_add_front֐̗] NULL`FbN폜B
	           Eppps_int_clist_remove_elem_by_value֐̗] NULL`FbN폜B
	        
	         1.0.0   '2015/1/11
*/

#include "ppps_int_clist.h"
#include <stdio.h>
#include <stdlib.h>

#define PPP_SWAP(type,a,b) { type work = a; a = b; b = work; }


/*
	Xg쐬
*/
PPPSIntClist ppps_int_clist_create(void)
{
	struct PPPSIntClist_tag* head = malloc( sizeof(struct PPPSIntClist_tag) );
	if( head == NULL ){
		return NULL;
	}

	head->value = 0;
	head->next = head;  // z̂ next|C^͎gw
	head->prev = head;  // z̂ prev|C^͎gw

	return head;
}

/*
	Xgj
*/
void ppps_int_clist_delete(PPPSIntClist list)
{
	ppps_int_clist_clear( list );

	free( list );
}

/*
	Xg̖ɗvfǉ
*/
bool ppps_int_clist_add_tail(PPPSIntClist list, int value)
{
	// Xg̖𓾂
	PPPSIntClist tail = ppps_int_clist_get_tail( list );

	// ǉvf
	PPPSIntClist elem = malloc( sizeof(struct PPPSIntClist_tag) );
	if( elem == NULL ){
		return false;
	}
	elem->value = value;
	elem->next = list;   // ɒǉ̂ŁA̗vf͐擪
	elem->prev = tail;   // ɒǉ̂ŁAO̗vf͂܂łɖvf

	// ܂Ŗvf́AQԖڂ̈ʒuɂȂB
	// ̂߁AnextoāAVȖ̗vfw悤ɂ
	tail->next = elem;

	// _~[̐擪̑ÓA̗vfɂȂ
	list->prev = elem;

	return true;
}

/*
	Xg̐擪ɗvfǉ
*/
bool ppps_int_clist_add_front(PPPSIntClist list, int value)
{
	// ǉvf
	PPPSIntClist elem = malloc( sizeof(struct PPPSIntClist_tag) );
	if( elem == NULL ){
		return false;
	}
	elem->value = value;
	elem->next = list->next;
	elem->prev = list;

	// ǉvf(elem) ̎ɂvfA
	// O̗vfƂāAelem w悤Ƀ|C^tւ
	elem->next->prev = elem;

	// _~[̐擪vf̎́AǉvfɂȂ
	list->next = elem;

	return true;
}

/*
	Xgɗvf}
*/
bool ppps_int_clist_insert(PPPSIntClist list, int value, int pos)
{
	// ǉʒuT
	PPPSIntClist p = ppps_int_clist_search( list, pos );
	if( p == NULL ){
		return false;
	}

	// ǉvf
	PPPSIntClist elem = malloc( sizeof(struct PPPSIntClist_tag) );
	if( elem == NULL ){
		return false;
	}
	elem->value = value;
	elem->next = p->next;  // p  p->next ̌Ԃɑ}
	elem->prev = p;        // p  p->next ̌Ԃɑ}

	p->next = elem;           // p ̒ɑ}ꂽ
	elem->next->prev = elem;  // elem->next ɂƂĂ prev ́A}ꂽ elem
	
	return true;
}

/*
	vf폜
*/
int ppps_int_clist_remove_elem_by_value(PPPSIntClist list, int value)
{
	PPPSIntClist p = list->next;
	PPPSIntClist prev = list;
	int count = 0;

	while( p != list ){
		if( p->value == value ){
			// 폜vf̂P̗vf prevóA
			// 폜vf̂PO̗vfw悤ɏB
			p->next->prev = prev;

			// 폜vf̂PO̗vf nextoA
			// 폜vf̗̎vfw悤ɏ
			prev->next = p->next;

			// vf malloc֐Ő̂ŁAfree֐ɂKvB
			// L prev->next = p->next ōsȂƁAsȃ|C^
			// prev->next ɑĂ܂ƂɒӁB
			free( p );

			// sȂAp 𐳂vfw悤ɂ
			p = prev->next;

			++count;
		}
		else{
			prev = p;
			p = p->next;
		}
	}

	return count;
}

/*
	vf폜
*/
bool ppps_int_clist_remove_elem(PPPSIntClist elem)
{
	if( elem->next == elem ){  // next ĝƂ͋
		return false;
	}

	elem->prev->next = elem->next;
	elem->next->prev = elem->prev;

	free( elem );
	return true;
}

/*
	vfɂ
*/
void ppps_int_clist_clear(PPPSIntClist list)
{
	PPPSIntClist p = list->next;

	while( p != list ){
		// 폜vf̂P̗vf̃|C^ۑ
		PPPSIntClist tmp = p->next;

		// vf malloc֐Ő̂ŁAfree֐ɂKvB
		// free֐ʂ p ͕sɂȂ̂ŁǍ p->next ͕sB
		free( p );

		// ۑĂ|C^𕜌
		p = tmp;
	}

	list->next = list;
	list->prev = list;
}

/*
	擪̗vfԂ
*/
PPPSIntClist ppps_int_clist_get_head(PPPSIntClist list)
{
	return list->next;
}

/*
	̗vfԂ
*/
PPPSIntClist ppps_int_clist_get_tail(PPPSIntClist list)
{
	return list->prev;
}

/*
	w肵lvfT
*/
PPPSIntClist ppps_int_clist_search(PPPSIntClist list, int value)
{
	PPPSIntClist p = list->next;

	while( p != list ){
		if( p->value == value ){
			return p;
		}
		p = p->next;
	}

	return NULL;
}

/*
	vfJEgB
	
	߂lF
		XgɊ܂܂vf̌B
*/
int ppps_int_clist_count(PPPSIntClist list)
{
	PPPSIntClist p = list->next;
	int count = 0;

	while( p != list ){
		count++;
		p = p->next;
	}

	return count;
}

/*
	XgtɂB
*/
void ppps_int_clist_reverse(PPPSIntClist list)
{
	PPPSIntClist p = list->next;
	PPPSIntClist work = NULL;

	while( p != list ){

		// ̌Ap->next ̂őޔĂ
		PPPSIntClist tmp = p->next;

		// next  prev ւ
		PPP_SWAP(PPPSIntClist, p->next, p->prev);

		// ݂̒ڗvfۑ
		work = p;

		// ŏɑޔĂ p->next ̒ڗvfƂĕA
		p = tmp;
	}

	// ŏII work ́AtɂȂ̐擪vfł邩A
	// _~[̐擪vf next|C^ƂĐݒ肷
	list->next = work;

	// tɂȂ̐擪vfɂ́AO̗vf݂͑Ȃ
	list->prev = NULL;
}

/*
	vfo͂
*/
void ppps_int_clist_print(PPPSIntClist list)
{
	PPPSIntClist p = list->next;

	if( p == list ){
		puts( "Xg͋łB" );
		return;
	}

	while( p != list ){
		printf( "%d\n", p->value );
		p = p->next;
	}
}
