/*
	ppps_int_slist.c
	[TvCu] int^̒P`Xg
	
	author:  K.Y (Programming Place Plus)
	
	version  1.0.2   '2019/9/16
               EۂԂ֐̖߂lɁAbool^g悤ɂ
             
             1.0.1   '2019/9/13
	           EWebTCg C99Ki֑ΉƂɍ킹āAR[hCB
			     RgX^CƁAϐ錾ʒuςB

             1.0.0   '2012/1/4
*/

#include "ppps_int_slist.h"
#include <stdio.h>
#include <stdlib.h>


/*
	Xg쐬
*/
PPPSIntSlist ppps_int_slist_create(void)
{
	struct PPPSIntSlist_tag* head = malloc( sizeof(struct PPPSIntSlist_tag) );
	if( head == NULL ){
		return NULL;
	}

	head->value = 0;
	head->next = NULL;

	return head;
}

/*
	Xgj
*/
void ppps_int_slist_delete(PPPSIntSlist list)
{
	ppps_int_slist_clear( list );

	free( list );
}

/*
	Xg̖ɗvfǉ
*/
bool ppps_int_slist_add_tail(PPPSIntSlist list, int value)
{
	// Xg̖T
	PPPSIntSlist tail = ppps_int_slist_search_tail( list );

	// ǉvf
	PPPSIntSlist elem = malloc( sizeof(struct PPPSIntSlist_tag) );
	if( elem == NULL ){
		return false;
	}
	elem->value = value;
	elem->next = NULL;   // ɒǉ̂ŁA̗vf͖

	// ܂Ŗvf́AQԖڂ̈ʒuɂȂB
	// ̂߁AnextoāAVȖ̗vfw悤ɂ
	tail->next = elem;

	return true;
}

/*
	Xg̐擪ɗvfǉ
*/
bool ppps_int_slist_add_front(PPPSIntSlist list, int value)
{
	// ǉvf
	PPPSIntSlist elem = malloc( sizeof(struct PPPSIntSlist_tag) );
	if( elem == NULL ){
		return false;
	}
	elem->value = value;
	elem->next = list->next;

	// _~[̐擪vf̎́AǉvfɂȂ
	list->next = elem;

	return true;
}

/*
	Xgɗvf}
*/
bool ppps_int_slist_insert(PPPSIntSlist list, int value, int pos)
{
	// ǉʒuT
	PPPSIntSlist p = ppps_int_slist_search( list, pos );
	if( p == NULL ){
		return false;
	}

	// ǉvf
	PPPSIntSlist elem = malloc( sizeof(struct PPPSIntSlist_tag) );
	if( elem == NULL ){
		return false;
	}
	elem->value = value;
	elem->next = p->next;  // p  p->next ̌Ԃɑ}

	p->next = elem;
	
	return true;
}

/*
	vf폜
*/
int ppps_int_slist_delete_elem(PPPSIntSlist list, int value)
{
	PPPSIntSlist p = list->next;
	PPPSIntSlist prev = list;
	int count = 0;

	while( p != NULL ){
		if( p->value == value ){
			// 폜vf̂PO̗vf nextoA
			// 폜vf̗̎vfw悤ɏ
			prev->next = p->next;

			// vf malloc֐Ő̂ŁAfree֐ɂKvB
			// L prev->next = p->next ōsȂƁAsȃ|C^
			// prev->next ɑĂ܂ƂɒӁB
			free( p );

			// sȂAp 𐳂vfw悤ɂ
			p = prev->next;

			++count;
		}
		else{
			prev = p;
			p = p->next;
		}
	}

	return count;
}

/*
	vfɂ
*/
void ppps_int_slist_clear(PPPSIntSlist list)
{
	PPPSIntSlist p = list->next;

	while( p != NULL ){
		// 폜vf̂P̗vf̃|C^ۑ
		PPPSIntSlist tmp = p->next;

		// vf malloc֐Ő̂ŁAfree֐ɂKvB
		// free֐ʂ p ͕sɂȂ̂ŁǍ p->next ͕sB
		free( p );

		// ۑĂ|C^𕜌
		p = tmp;
	}
}

/*
	̗vfT
*/
PPPSIntSlist ppps_int_slist_search_tail(PPPSIntSlist list)
{
	PPPSIntSlist p = list;

	while( p->next != NULL ){
		p = p->next;
	}

	return p;
}

/*
	w肵lvfT
*/
PPPSIntSlist ppps_int_slist_search(PPPSIntSlist list, int value)
{
	PPPSIntSlist p = list->next;

	while( p != NULL ){
		if( p->value == value ){
			return p;
		}
		p = p->next;
	}

	return NULL;
}

/*
	vfJEgB
	
	߂lF
		XgɊ܂܂vf̌B
*/
int ppps_int_slist_count(PPPSIntSlist list)
{
	PPPSIntSlist p = list->next;
	int count = 0;

	while( p != NULL ){
		count++;
		p = p->next;
	}

	return count;
}

/*
	XgtɂB
*/
void ppps_int_slist_reverse(PPPSIntSlist list)
{
	PPPSIntSlist p = list->next;
	PPPSIntSlist work = NULL;

	while( p != NULL ){

		// ̌Ap->next ̂őޔĂ
		PPPSIntSlist tmp = p->next;

		// PO̗vf p->next ɐݒ
		// "PO̗vf" Ƃ͐擪疖֌̒ł̂ƂĂA
		// tɂȂ̂ƂlƁA"̗vf" ̂ƂĂB
		// ͉Ȃ̂ NULL ɂȂĂ
		p->next = work;

		// ݂̒ڗvfۑ
		// ́Ã[vɂĂ "PO̗vf" ɂȂ
		work = p;

		// ŏɑޔĂ p->next ̒ڗvfƂĕA
		p = tmp;
	}

	// ŏII work ́AtɂȂ̐擪vfł邩A
	// _~[̐擪vf next|C^ƂĐݒ肷
	list->next = work;
}

/*
	vfo͂
*/
void ppps_int_slist_print(PPPSIntSlist list)
{
	PPPSIntSlist p = list->next;

	if( p == NULL ){
		puts( "Xg͋łB" );
		return;
	}

	while( p != NULL ){
		printf( "%d\n", p->value );
		p = p->next;
	}
}
